#!/usr/bin/python
# -*- coding: euc-jp -*-
import string
import re

# Ԥñ줴Ȥʬ䤹
lre = re.compile( r'([\x81-\x9f\xe0-\xfc][\x40-\x7e\x80-\xfc]|.)' )
# define 뤫ɤΥե饰
def_chk = re.compile( r'^(#\s*)(include|define|ifdef|elif|else|endif|if).*', re.I )

#
# ""ǰϤޤ줿ʸФ
#
def get_string(str):
	assert str[0] == '"'

	l = len(str)
	out = '"'
	force = False
	for i in xrange(1, l, 1):
		ch = str[i]
		out = out + ch
		if ch == '\\':
			force = True
		elif (not force) and ch == '"':
			i = i + 1
			break;
		else:
			force = False

	return (i, out)

#
# /**/ Ȥ
#
def pass_comment(str):
	assert str[0] == '/'
	assert str[1] == '*'
	l = len(str)
	out = '/*'
	for i in xrange(2, l, 1):
		if str[i] == '*':
			if i < (l-1):
				if str[i+1] == '/':
					out = out + '*/'
					i = i + 2
					break
		out = out + str[i]
	return (i, out)

#
# 
#
def get_number(str):
	assert str[0].isdigit()

	l = len(str)
	out = ''
	for i in xrange(0, l, 1):
		ch = str[i]
		if ch.isalnum():
			out = out + ch
		else:
			break

	return (len(out), out)

#
# ñ
#
def get_word(str):
	assert str[0].isalpha() or str[0] == '_'

	l = len(str)
	out = ''
	for i in xrange(0, l, 1):
		ch = str[i]
		if ch.isalnum() or ch == '_':
			out = out + ch
		else:
			break

	return (len(out), out)

#
# ¾Τ(Ȥ)
#
def punct(str):
	out = ''
	i = 0
	try:
		ch = str[i]
		if ch == '<':
			out = '<'
			i = i + 1
			ch = str[i]
			if ch == '>' or ch == '=':
				out = out + ch
				i = i + 1
		elif ch == '>':
			out = '>'
			i = i + 1
			ch = str[i]
			if ch == '=':
				out = out + '='
				i = i + 1
		elif ch == '=':
			out = '='
			i = i + 1
			ch = str[i]
			if ch == '=':
				out = out + '='
				i = i + 1
		elif ch == '!':
			out = '!'
			i = i + 1
			ch = str[i]
			if ch == '=':
				out = out + '='
				i = i + 1
		elif ch == '&':
			out = '&'
			i = i + 1
			ch = str[i]
			if ch == '&':
				out = out + '&'
				i = i + 1
		elif ch == '|':
			out = '|'
			i = i + 1
			ch = str[i]
			if ch == '|':
				out = out + '|'
				i = i + 1
		else:
			out = ch
			i = i + 1
	except IndexError:
		# 󳰻ȤƤޤä餽ǽ
		pass

	return (i, out)

#
# Ԥñ줴Ȥʬ䤷ƼФ
# ʬɲäʤ褦ˤƤߤ
#
def scan(str):
	s = lre.split(str)
	# split Ǥȴ֤NoneΤ
	# äƺƹ
	ss = []
	for ch in s:
		if not ch:
			continue
		ss.append(ch)

	# ʬ
	out = []

	l = len(ss)
	i = 0
	while True:
		if i >= l:
			break
		ch = ss[i]
		assert ch

		if i == 0 and ch == '#':
			# ץץå
			g = def_chk.match(str)
			if g:
				out.append( '#' + g.group(2) )
				i = i + len(g.group(1)+g.group(2))
			else:
				# Ƭ # 
				out.append('#')
				i = i + 1
		elif ch.isspace():
			out.append(ch)
			i = i + 1
		elif ch == '"':
			# ʸ
			(cnt, str) = get_string(ss[i:])
			i = i + cnt
			out.append(str)
		elif ch == '/':
			if i < (l-1):
				ch = ss[i+1]
				if ch == '*':
					# 
					(cnt, str) = pass_comment(ss[i:])
					i = i + cnt
					out.append(str)
				elif ch == '/':
					# Ĥ
					s = ''.join(ss[i:])
					out.append(s)
					break
				else:
					out.append('/')
					i = i + 1
			else:
				out.append('/')
				i = i + 1
		elif ch.isdigit():
			# 
			(cnt, str) = get_number(ss[i:])
			i = i + cnt
			out.append(str)
		elif ch.isalpha() or ch == '_':
			# ñ
			(cnt, str) = get_word(ss[i:])
			i = i + cnt
			out.append(str)
		else:
			# ʳ
			(cnt, str) = punct(ss[i:])
			i = i + cnt
			out.append(str)

	return out

